<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSignalStrengthHistoryOutput StructType
 * @subpackage Structs
 */
class GetSignalStrengthHistoryOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The SignalStrengthHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfSignalStrengthInfo
     */
    public $SignalStrengthHistory;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for GetSignalStrengthHistoryOutput
     * @uses GetSignalStrengthHistoryOutput::setSuccess()
     * @uses GetSignalStrengthHistoryOutput::setSignalStrengthHistory()
     * @uses GetSignalStrengthHistoryOutput::setErrorMessage()
     * @param bool $success
     * @param \CustomerManagement\ArrayType\ArrayOfSignalStrengthInfo $signalStrengthHistory
     * @param string $errorMessage
     */
    public function __construct($success = null, \CustomerManagement\ArrayType\ArrayOfSignalStrengthInfo $signalStrengthHistory = null, $errorMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setSignalStrengthHistory($signalStrengthHistory)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\GetSignalStrengthHistoryOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get SignalStrengthHistory value
     * @return \CustomerManagement\ArrayType\ArrayOfSignalStrengthInfo|null
     */
    public function getSignalStrengthHistory()
    {
        return $this->SignalStrengthHistory;
    }
    /**
     * Set SignalStrengthHistory value
     * @param \CustomerManagement\ArrayType\ArrayOfSignalStrengthInfo $signalStrengthHistory
     * @return \CustomerManagement\StructType\GetSignalStrengthHistoryOutput
     */
    public function setSignalStrengthHistory(\CustomerManagement\ArrayType\ArrayOfSignalStrengthInfo $signalStrengthHistory = null)
    {
        $this->SignalStrengthHistory = $signalStrengthHistory;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\GetSignalStrengthHistoryOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
